# Transformation (ARX Developer Documentation)

org.deidentifier.arx.framework.lattice

## Class Transformation

- java.lang.Object
- - org.deidentifier.arx.framework.lattice.Transformation

-     public class Transformation
      extends java.lang.Object

  The class Transformation.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Transformation(int[] transformation, de.linearbits.jhpl.Lattice<java.lang.Integer,java.lang.Integer> lattice, SolutionSpace solutionSpace)` Instantiates a new transformation.
    `Transformation(int[] transformationJHPL, long identifier, de.linearbits.jhpl.Lattice<java.lang.Integer,java.lang.Integer> lattice, SolutionSpace solutionSpace)` Instantiates a new transformation.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.Object` | `getData()` Returns associated data
    `int[]` | `getGeneralization()` Returns the generalization
    `long` | `getIdentifier()` Returns the id
    `InformationLoss<?>` | `getInformationLoss()` Returns the information loss
    `int` | `getLevel()` Return level
    `InformationLoss<?>` | `getLowerBound()` Returns the lower bound on information loss
    `cern.colt.list.LongArrayList` | `getPredecessors()` Returns all predeccessors of the transformation with the given identifier
    `cern.colt.list.LongArrayList` | `getSuccessors()` Returns all successors
    `boolean` | `hasProperty(de.linearbits.jhpl.PredictiveProperty property)` Returns whether this transformation has a given property
    `void` | `setChecked(NodeChecker.Result result)` Sets the properties to the given node.
    `void` | `setData(java.lang.Object object)` Sets a data
    `void` | `setInformationLoss(InformationLoss<?> informationLoss)` Sets the information loss
    `void` | `setLowerBound(InformationLoss<?> lowerBound)` Sets the lower bound
    `void` | `setProperty(de.linearbits.jhpl.PredictiveProperty property)` Sets a property
    `void` | `setPropertyToNeighbours(de.linearbits.jhpl.PredictiveProperty property)` Sets the property to all neighbors
    `java.lang.String` | `toString()` Returns a string representation

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### Transformation

          public Transformation(int[] transformation,
                        de.linearbits.jhpl.Lattice<java.lang.Integer,java.lang.Integer> lattice,
                        SolutionSpace solutionSpace)

      Instantiates a new transformation.
      Parameters:
        `transformation` - In ARX space
        `lattice` -
        `solutionSpace` -

    - #### Transformation

          public Transformation(int[] transformationJHPL,
                        long identifier,
                        de.linearbits.jhpl.Lattice<java.lang.Integer,java.lang.Integer> lattice,
                        SolutionSpace solutionSpace)

      Instantiates a new transformation.
      Parameters:
        `transformationJHPL` -
        `identifier` -
        `lattice2` -
        `solutionSpace2` -

  - ### Method Detail

    - #### getData

          public java.lang.Object getData()

      Returns associated data
      Returns:

    - #### getGeneralization

          public int[] getGeneralization()

      Returns the generalization
      Returns:

    - #### getIdentifier

          public long getIdentifier()

      Returns the id
      Returns:

    - #### getInformationLoss

          public InformationLoss<?> getInformationLoss()

      Returns the information loss
      Returns:

    - #### getLevel

          public int getLevel()

      Return level
      Returns:

    - #### getLowerBound

          public InformationLoss<?> getLowerBound()

      Returns the lower bound on information loss
      Returns:

    - #### getPredecessors

          public cern.colt.list.LongArrayList getPredecessors()

      Returns all predeccessors of the transformation with the given identifier
      Parameters:
        `transformation` -
      Returns:

    - #### getSuccessors

          public cern.colt.list.LongArrayList getSuccessors()

      Returns all successors
      Returns:

    - #### hasProperty

          public boolean hasProperty(de.linearbits.jhpl.PredictiveProperty property)

      Returns whether this transformation has a given property
      Parameters:
        `property` -
      Returns:

    - #### setChecked

          public void setChecked(NodeChecker.Result result)

      Sets the properties to the given node.
      Parameters:
        `node` - the node
        `result` - the result

    - #### setData

          public void setData(java.lang.Object object)

      Sets a data
      Parameters:
        `object` -

    - #### setInformationLoss

          public void setInformationLoss(InformationLoss<?> informationLoss)

      Sets the information loss
      Parameters:
        `informationLoss` -

    - #### setLowerBound

          public void setLowerBound(InformationLoss<?> lowerBound)

      Sets the lower bound
      Parameters:
        `lowerBound` -

    - #### setProperty

          public void setProperty(de.linearbits.jhpl.PredictiveProperty property)

      Sets a property
      Parameters:
        `property` -

    - #### setPropertyToNeighbours

          public void setPropertyToNeighbours(de.linearbits.jhpl.PredictiveProperty property)

      Sets the property to all neighbors
      Parameters:
        `property` -

    - #### toString

          public java.lang.String toString()

      Returns a string representation
      Overrides:
        `toString` in class `java.lang.Object`